// Copyright (c) 2015, the package authors. Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// MIT license that can be found in the LICENSE file.

part of dartiny_event_dispatcher;

class EventDispatcher {

  final Map<String, List<_EventSubscription>> _subscriptions;

  EventDispatcher(Map<String, List<_EventSubscription>> this._subscriptions);

  Future<Event> dispatch(String eventName, [Event event]) async {
    if (event == null) {
      event = new Event();
    }

    if (!_subscriptions.containsKey(eventName)) {
      return event;
    }

    for (var subscription in _subscriptions[eventName]) {
      if (event.isPropagationStopped) break;

      await subscription.listener(eventName, event);
    }

    return event;
  }
}